package de.intevation.flys.themes;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import de.intevation.artifacts.common.utils.XMLUtils;
import de.intevation.artifacts.common.utils.XMLUtils.ElementCreator;


/**
 * @author <a href="mailto:ingo.weinzierl@intevation.de">Ingo Weinzierl</a>
 */
public class DefaultThemeField implements ThemeField {

    protected String name;

    protected Map<String, Object> attr;


    public DefaultThemeField(String name) {
        this.name = name;
        this.attr = new HashMap<String, Object>();
    }


    public String getName() {
        return name;
    }


    public String getType() {
        return (String) getAttribute("type");
    }


    public Object getValue() {
        return getAttribute("value");
    }


    public void setValue(Object value) {
        setAttribute("value", value);
    }


    public Object getAttribute(String name) {
        return attr.get(name);
    }


    public void setAttribute(String name, Object value) {
        if (name == null || value == null) {
            return;
        }

        attr.put(name, value);
    }


    public Document toXML() {
        Document doc = XMLUtils.newDocument();

        ElementCreator cr = new ElementCreator(doc, null, null);

        Element field = cr.create("field");

        Iterator<String> iter = attr.keySet().iterator();

        while (iter.hasNext()) {
            String name  = iter.next();
            String value = (String) getAttribute(name);

            cr.addAttr(field, name, value);
        }

        doc.appendChild(field);

        return doc;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
